# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without mead
%define _jarsign_opts --copy=%{_javadir} --unsign=%{_javadir}

%if %with mead
%bcond_with repolib
%else
%bcond_without repolib
%endif

%define reltag Final

%global alternativespriority 010000
%global apiname jaspi
%global apiversion 1.0
%global apiversionu 1_0
%global plainversion %{version}.%{reltag}
%global namedversion %{version}.%{reltag}-redhat-2
%global apigroupid javax.security.auth.message
%global apiartifactid %{apiname}-api

%define section free

%define maven_version 1.0.1.Final-redhat-2

Name:           jboss-%{apiname}-api_%{apiversion}_spec
Version:        1.0.1
Release:        6.%{reltag}_redhat_2%{?dist}
Epoch:          0
Summary:        Java API for XML-Based RPC (JAX-RPC) %{apiversion}
License:        LGPLv2+
URL:            http://fisheye.jboss.org/browse/JBossAS/projects/specs/tags/jboss-%{apiname}-api_%{apiversion}_spec-%{plainversion}
Group:          Development/Libraries/Java

%if %with mead
Source100: org.jboss.spec.javax.security.auth.message-jboss-jaspi-api_1.0_spec-1.0.1.Final-redhat-2-sources.zip
Source101: org.jboss.spec.javax.security.auth.message-jboss-jaspi-api_1.0_spec-1.0.1.Final-redhat-2-patches.zip
Source102: jboss-jaspi-api_1.0_spec-1.0.1.Final-redhat-2-sources.jar
Source103: jboss-jaspi-api_1.0_spec-1.0.1.Final-redhat-2-javadoc.jar
Source104: jboss-jaspi-api_1.0_spec-1.0.1.Final-redhat-2.jar
Source105: jboss-jaspi-api_1.0_spec-1.0.1.Final-redhat-2.pom
%endif

# svn export http://anonsvn.jboss.org/repos/jbossas/projects/specs/tags/jboss-jaspi-api_1.0_spec-1.0.0.Final && tar cjf jboss-jaspi-api_1.0_spec-1.0.0.Final.tar.bz2 jboss-jaspi-api_1.0_spec-1.0.0.Final
# Exported revision 110833.
#Source0:        jboss-%{apiname}-api_%{apiversion}_spec-%{plainversion}.tar.bz2
#Source2:        jboss-%{apiname}-api_%{apiversion}_spec-jpp-depmap.xml
#Source3:        jaspi-api-1.0.pom
#Patch0:         jboss-%{apiname}-api_%{apiversion}_spec-pom.patch
Provides:       %{apiname}_%{apiversionu}_api
Provides:       %{apiname}_api = 0:%{apiversion}

%if %without mead
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
Requires:       jboss-specs-parent
Requires:       servlet_3_0_api
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-project-info-reports-plugin
BuildRequires:  maven-skins
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven-surefire-report-plugin
BuildRequires:  mojo-maven2-plugin-taglist
BuildRequires:  jboss-parent
BuildRequires:  jboss-specs-parent 
%endif

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The JAX-RPC %{apiversion} API classes.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%if %without mead
%setup -q -n jboss-%{apiname}-api_%{apiversion}_spec-%{plainversion}
%patch0 -p1 -b .sav0
%endif

%build
%if %without mead
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
%{_bindir}/mvn-jpp \
        -e \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -DaltDeploymentRepository=oss-releases::default::file:maven2-brew \
        javadoc:javadoc javadoc:jar source:jar deploy site
%endif

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%if %without mead
pushd maven2-brew
%{__cp} -p org/jboss/spec/javax/xml/rpc/jboss-%{apiname}-api_%{apiversion}_spec/%{namedversion}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}.jar %{buildroot}%{_javadir}
%{__cp} -p org/jboss/spec/javax/xml/rpc/jboss-%{apiname}-api_%{apiversion}_spec/%{namedversion}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}-sources.jar %{buildroot}%{_javadir}
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p org/jboss/spec/javax/xml/rpc/jboss-%{apiname}-api_%{apiversion}_spec/%{namedversion}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-jboss-%{apiname}-api_%{apiversion}_spec.pom
popd
%else
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}-sources.jar

# poms
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-jboss-%{apiname}-api_%{apiversion}_spec.pom
%endif
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# depmaps
%add_to_maven_depmap org.jboss.spec.javax.xml.rpc jboss-%{apiname}-api_%{apiversion}_spec %{namedversion} JPP jboss-%{apiname}-api_%{apiversion}_spec
%add_to_maven_depmap %{apigroupid} %{apiartifactid} %{apiversion} JPP jboss-%{apiname}-api_%{apiversion}_spec

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__unzip} -qq %{_sourcedir}/%{name}-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__rm} -r %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/META-INF
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%if %without mead
%doc LICENSE, README
%endif
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}.jar
%{_javadir}*/jboss-%{apiname}-api_%{apiversion}_spec.jar
%{_javadir}*/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}-sources.jar
%{_javadir}*/jboss-%{apiname}-api_%{apiversion}_spec-sources.jar
%{_datadir}/maven2/poms/JPP-jboss-%{apiname}-api_%{apiversion}_spec.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.1-6.Final_redhat_2
- Rebuild for MD5

* Mon Aug 20 2012 Honza Brazdil <jbrazdil@redhat.com> - 0:1.0.1-5.Final_redhat_2
- Update pom patch for eap 6.0.1

* Fri Aug 10 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.1-4.Final_redhat_2.2
- Rebuild unsigned

* Thu Jul 12 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.1-4.Final_redhat_1.1
- Rebuild using cache signing

* Tue Jun 12 2012 David Walluck <dwalluck@redhat.com> 0:1.0.1-4
- fix macro in comment

* Tue Jun 12 2012 David Walluck <dwalluck@redhat.com> 0:1.0.1-3
- enable mead option
- remove update-alternatives Requires from javadoc pkg
- fix depmap
- remove ghost from file list
- set maven groupId to javax.security.auth.message

* Thu May 31 2012 Permaine Cheung <pcheung@redhat.com> 0:1.0.1-2.Final_redhat_1
- Remove javadoc.jar from main package and add back -javadoc subpackage

* Thu May 03 2012 Hui Wang <huwang@redhat.com> 0:1.0.1-1.Final_redhat_1
- Upgrade to 1.0.1.Final

* Thu Mar 15 2012 Hui Wang <huwang@redhat.com> 0:1.0.0-5.Final_redhat_1.1
- New wrapper
- Fix installing path
- Fix release tag

* Tue Jan 31 2012 Fernando Nasser <fnasser@redhat.com> 0:1.0.0-4
- Fix typo in spec dependency

* Fri Jan 27 2012 Fernando Nasser <fnasser@redhat.com> 0:1.0.0-3
- Require Servlet 3.0 not 2.5
- Resign with new key
- Adapt to Wolf suffix on MEAD build

* Tue Jun 14 2011 Lin Gao <lgao@redhat.com> 0:1.0.0-1
- Adapt for EAP 6
- no repolib when building with MEAD

* Thu May 26 2011 Fernando Nasser <fnasser@redhat.com> 0:1.0.0-1
- Adapted from jboss-jaxrpc_1.1_spec
